#include <stdio.h>

#define DIM	200
#define FILENAME	"numeri.txt"

void swap(int *x, int *y)
{
	int aux = *x;

	*x = *y;
	*y = aux;
}

void leggiarray(FILE *fp, int *a, int n)
{
	int i;

	for(i = 0; i < n; i++)
		fscanf(fp,"%d",&a[i]);
}

void selectionsort(int *a, int n)
{
	int i, j, min;

	for(i = 0; i < n - 1; i++) {
		for(min = i, j = i + 1; j < n; j++)
			if(a[j] < a[min])
				min = j;
		swap(&a[i],&a[min]);
	}
}

/* ricerca binaria, versione ricorsiva */
int rbinsearch(int *a, int l, int r, int n)
{
	int m = (l+r)/2;

	if(a[m] == n)
		return m;
	if(m == l)
		return -1;
	if(a[m] > n)
		return rbinsearch(a,l,m,n);
	else
		return rbinsearch(a,m+1,r,n);
}

/* ricerca binaria, versione iterativa */
int ibinsearch(int *a, int l, int r, int n)
{
	int m = (l+r)/2;

	while(a[m] != n && m != l) {
		if(a[m] > n)
			r = m;
		else
			l = m+1;
		m = (l+r)/2;
	}
	return a[m] == n ? m : -1;
}

int main(void)
{
	int a[DIM],n,pos;
	FILE *fp = fopen(FILENAME,"r");

	if(!fp) {
		fprintf(stderr,"Non riesco a leggere il file \"numeri.txt\"\n");
		return -1;
	}

	leggiarray(fp,a,DIM);
	selectionsort(a,DIM);

	printf("Immetti elemento da ricercare:");
	scanf("%d",&n);
	
	printf("Elemento %d ",n);
	if((pos = rbinsearch(a,0,DIM,n)) != -1)
		printf("trovato in posizione %d.\n",pos);
	else
		printf("non trovato.\n");

	printf("Elemento %d ",n);
	if((pos = ibinsearch(a,0,DIM,n)) != -1)
		printf("trovato in posizione %d.\n",pos);
	else
		printf("non trovato.\n");

	return 0;
}
