/* Frazioni Egizie. */
/* Data una frazione 0 < a/b <= 1, la sviluppa come */
/* a/b = 1/d1 - 1/(d1*d2) + 1/(d1*d2*d3) - 1/(d1*d2*d3*d4) ... 1/(d1*d2* ... *dn) */

/* Versione con frazione implementata come array di due interi */

#include <stdio.h>

/* restituisce il gcd di a e b calcolato con l'algoritmo di Euclide */
unsigned gcd(unsigned a, unsigned b)
{
	unsigned t;

	while(b) {
		t = b;
		b = a % b;
		a = t;
	}
	return a;
}

void stampafrazione(int *f)
{
	printf("%d",f[0]);
	if(f[1] > 1)
		printf("/%d",f[1]);
}

/* calcola la forma irriducibile della frazione f */
void formairriducibile(int *f)
{
	short sign = f[0] >= 0 ? 1 : -1;
	int d = (int)gcd(sign * f[0],f[1]);
	
	f[0] /= d;
	f[1] /= d;
}


/* Data h/k calcola la prossima frazione h'/k' da espandere nello sviluppo in frazioni egizie: */
/* d = floor(h/k) */
/* h/k = 1/d - 1/d * (h'/k') */
/* restituisce il valore di d */ 
int prossimafrazione(int *f)
{
	int d = f[1] / f[0];

	f[0] = f[1] - f[0] * d;
	formairriducibile(f);
	return d;		
}

int main(void)
{
	int f[2];
	int den,newden;
	char parity = 0; /* per gestire nello sviluppo l'alternanza +/- del segno  */

	printf("Immetti numeratore e denominatore della frazione:\n");
	scanf("%d %d",&f[0],&f[1]);
	if(f[1] <= 0) {
		printf("Errore di immissione, il denominatore %d non e' > 0\n",f[1]);
		return -1;
	}
	if(f[0] > f[1]) {
		printf("Errore di immissione, il denominatore %d non e' maggiore del numeratore %d\n",f[1],f[0]);
		return -1;
	}
	if(f[0] <= 0) {
		printf("Errore di immissione, il numeratore %d non e' > 0 \n",f[0]);
		return -1;
	}

	
	stampafrazione(f);
	printf(" = ");

	formairriducibile(f);
	den = 1;
	while(f[0] > 1) {
		newden = prossimafrazione(f);
		printf("1/%d %c ", den *= newden, ++parity % 2 ? '-' : '+');		
	}
	printf("1/%d\n",f[1] * den);	

	return 0;
}
