#include <stdio.h>

#define DIM	200
#define FILENAME	"numeri.txt"

void swap(int *x, int *y)
{
	int aux = *x;

	*x = *y;
	*y = aux;
}

void leggiarray(FILE *fp, int *a, int n)
{
	int i;

	for(i = 0; i < n; i++)
		fscanf(fp,"%d",&a[i]);
}

void stampaarray(int *a, int n)
{
	int i;

	for(i = 0; i < n; i++)
		printf("%d,",a[i]);
	putchar('\n');
}

void copiaarray(int *a, int *b, int n)
{
	int i;

	for(i = 0; i < n; i++)
		b[i] = a[i];
}

void bubblesort(int *a, int n)
{
	int i, j;

	for(i = 0; i < n - 1; i++)
		for(j = n - 1; j > i; j--)
			if(a[j-1] > a[j])
				swap(&a[j-1],&a[j]);
}

void selectionsort(int *a, int n)
{
	int i, j;

	for(i = 0; i < n - 1; i++)
		for(j = i + 1; j < n; j++)
			if(a[j] < a[i])
				swap(&a[j],&a[i]);
}

void selectionsort2(int *a, int n)
{
	int i, j, min;

	for(i = 0; i < n - 1; i++) {
		for(min = i, j = i + 1; j < n; j++)
			if(a[j] < a[min])
				min = j;
		swap(&a[i],&a[min]);
	}
}

void insertionsort(int *a, int n)
{
	int i, j;

	for(i = 1; i < n; i++)
		for(j = i; j; j--)
			if(a[j] < a[j-1])
				swap(&a[j-1],&a[j]);
}

void insertionsort2(int *a, int n)
{
	int i, j, k;

	for(i = n - 1; i; i--)
		if(a[i] < a[i-1])
			swap(&a[i],&a[i-1]);
	for(i = 2; i < n; i++) {
		for(j = i, k = a[i]; k < a[j-1]; j--)
			a[j] = a[j-1];
		a[j] = k;
	}
}

int main(void)
{
	int a[DIM], b[DIM];
	FILE *fp = fopen(FILENAME,"r");

	if(!fp) {
		fprintf(stderr,"Non riesco a leggere il file \"%s\"\n",FILENAME);
		return -1;
	}

	leggiarray(fp,a,DIM);

	copiaarray(a,b,DIM);
	bubblesort(b,DIM);
	stampaarray(b,DIM);

	copiaarray(a,b,DIM);
	selectionsort(b,DIM);
	stampaarray(b,DIM);

	copiaarray(a,b,DIM);
	selectionsort2(b,DIM);
	stampaarray(b,DIM);

	copiaarray(a,b,DIM);
	insertionsort(b,DIM);
	stampaarray(b,DIM);

	copiaarray(a,b,DIM);
	insertionsort2(b,DIM);
	stampaarray(b,DIM);

	fclose(fp);
	return 0;
}
