/* Frazioni egizie (inverso). Da una sequenza d1,d2,...dn, calcola la */
/* forma irriducibile della frazione */
/* a/b = 1/d1 - 1/(d1*d2) + 1/(d1*d2*d3) - 1/(d1*d2*d3*d4) ... 1/(d1*d2* ... *dn) */

/* Versione con frazione implementata come array di due interi */

#include <stdio.h>
#include <stdlib.h>

unsigned gcd(unsigned a, unsigned b)
{
	unsigned t;

	while(b) {
		t = b;
		b = a % b;
		a = t;
	}
	return a;
}

void stampafrazione(int *f)
{
	printf("%d",f[0]);
	if(f[1] > 1)
		printf("/%d",f[1]);
}

void formairriducibile(int *f)
{
	short sign = f[0] >= 0 ? 1 : -1;
	int d = (int)gcd(sign * f[0],f[1]);
	
	f[0] /= d;
	f[1] /= d;
}

/* somma f2 ad f1 */
void sommadifrazioni(int *f1, int *f2)
{
	f1[0] = f1[0] * f2[1] + f2[0] * f1[1];
	f1[1] = f1[1] * f2[1];
	formairriducibile(f1);
}

/* calcola la somma (con alternanza di segno) della frazioni i cui denominatori sono memorizzati in t */
/* e la pone nella frazione f*/ 
void calcolasomma(int n, int *f)
{
	static unsigned t = 1;
	unsigned t1;
	int i;
	int f2[2];

	f[0] = 0;
	f[1] = 1;
	for(i = 0; i < n; i++) {
		f2[0] = i % 2 ? -1 : 1;
		scanf("%u",&t1);
		f2[1] = t *= t1;
		sommadifrazioni(f,f2);				
	}		
}

int main(void)
{
	int n;
	int f[2];

	printf("Immetti il numero di termini:\n");
	scanf("%d",&n);
	
	printf("Immetti %d termini:\n",n);
	
	calcolasomma(n,f);
	stampafrazione(f);
	putchar('\n');
	
	return 0;
}
