/* Frazioni egizie (inverso). Da una sequenza d1,d2,...dn, calcola la */
/* forma irriducibile della frazione */
/* a/b = 1/d1 - 1/(d1*d2) + 1/(d1*d2*d3) - 1/(d1*d2*d3*d4) ... 1/(d1*d2* ... *dn) */

/* Versione con frazione implementata come struct */

#include <stdio.h>
#include <stdlib.h>

struct frazione {
	int numeratore;
	unsigned denominatore; 
};

unsigned gcd(unsigned a, unsigned b)
{
	unsigned t;

	while(b) {
		t = b;
		b = a % b;
		a = t;
	}
	return a;
}

void stampafrazione(struct frazione f)
{
	printf("%d",f.numeratore);
	if(f.denominatore > 1)
		printf("/%d",f.denominatore);
}

struct frazione formairriducibile(struct frazione f)
{
	short sign = f.numeratore >= 0 ? 1 : -1;
	unsigned d = gcd(sign * f.numeratore,f.denominatore);
	
	f.numeratore /= (int)d;
	f.denominatore /= d;
	return f;
}

/* restituisce la somma di f1 e f2 */
struct frazione sommadifrazioni(struct frazione f1, struct frazione f2)
{
	struct frazione somma;
	
	somma.numeratore = f1.numeratore * f2.denominatore + f2.numeratore * f1.denominatore;
	somma.denominatore = f1.denominatore * f2.denominatore;
	return formairriducibile(somma);	
}

/* restituisce la somma (con alternanza di segno) della frazioni i cui denominatori sono memorizzati in t */ 
struct frazione calcolasomma(int n)
{
	static unsigned t = 1;
	unsigned t1;
	int i;
	struct frazione f1 = {0,1}, f2;

	for(i = 0; i < n; i++) {
		f2.numeratore = i % 2 ? -1 : 1;
		scanf("%u",&t1);
		f2.denominatore = t *= t1;
		f1 = sommadifrazioni(f1,f2);				
	};
	return f1;		
}

int main(void)
{
	int n;
	struct frazione f;

	printf("Immetti il numero di termini:\n");
	scanf("%d",&n);
	
	printf("Immetti %d termini:\n",n);
	
	f = calcolasomma(n);
	stampafrazione(f);
	putchar('\n');
	
	return 0;
}
