#include <stdio.h>

#define MAXDIM		20
#define LEDSTICKS		7
#define HSPACING		"   "
#define VSPACING		' '
#define HORIZONTAL	" = "
#define VERTICAL		'|'


/* macro per accedere all'array monodimensionale digit come se fosse una tabella bidimensionale */
#define posto(i,j) 	(LEDSTICKS * (i) + (j))

static char digit[] = {
/*0*/		1,0,1,1,1,1,1,
/*1*/		0,0,0,0,1,0,1,
/*2*/		1,1,1,0,1,1,0,
/*3*/		1,1,1,0,1,0,1,
/*4*/		0,1,0,1,1,0,1,
/*5*/		1,1,1,1,0,0,1,
/*6*/		1,1,1,1,0,1,1,
/*7*/		1,0,0,0,1,0,1,
/*8*/		1,1,1,1,1,1,1,
/*9*/		1,1,1,1,1,0,1,
/*-*/		0,1,0,0,0,0,0
};

/* determina lo stato di una barretta orizzontale per ogni cifra */
/* e stampa le barrette accese */
/* buffer contiene il numero in formato stringa */
/* stick e' l'indice della barretta orizzontale */
void horizontal(char *buffer, short stick)
{
	short i;

	for(i = 0; buffer[i]; i++)
		printf(digit[posto(buffer[i]-'0',stick)] ? HORIZONTAL: HSPACING);
	putchar('\n');
}

/* determina lo stato di una coppia di barrette verticali per ogni cifra */
/* e stampa le barrette accese */
/* buffer contiene il numero in formato stringa */
/* stick e' l'indice della prima barretta verticale della coppia */
void vertical(char *buffer, short stick)
{
	short i;

	for(i = 0; buffer[i]; i++) {
		putchar(digit[posto(buffer[i]-'0',stick)] ? VERTICAL: VSPACING);
		putchar(VSPACING);
		putchar(digit[posto(buffer[i]-'0',stick+1)] ? VERTICAL: VSPACING);
	}
	putchar('\n');
}

/* stampa n come scritta LED */
void led(int n)
{
	char buffer[MAXDIM];
	
	/* memorizzo nella stringa buffer la sequenza di caratteri corrispondenti a n */
	sprintf(buffer,"%d",n);

	/* gestisco l'eventuale carattere '-' */
	/* in modo che corrisponda alla 10ma riga della tabella digit */
	if(buffer[0] == '-')
		buffer[0] = 10 + '0';

	horizontal(buffer,0);
	vertical(buffer,3);
	horizontal(buffer,1);
	vertical(buffer,5);
	horizontal(buffer,2);
}

int main(void)
{
	int n;

	printf("Immetti numero:\n");
	scanf("%d",&n);
	led(n);
	return 0;
}
