#include <stdio.h>

#define DIGITS	500

typedef char INT[DIGITS];

#define max(a,b)	((a) >= (b) ? (a) : (b))

/* carica un int in un INT */
void carica(INT n, int c)
{
	int i;

	for(i = 0; i < DIGITS;i++)
		n[i] = -1;
	if(!c) {
		n[0] = 0;
		return;
	}
	for(i = 0; i < DIGITS && c; i++) {
		n[i] = c % 10;
		c /= 10;
	}
}

/* stampa un INT */
void stampa(INT n)
{
	int i;

	for(i = 0; i < DIGITS && n[i] != -1; i++);
	while(i)	
		putchar(n[--i] + '0');
}

/* copia INT n2 in INT n1 */
void copia(INT n1, INT n2)
{
	int i;

	for(i = 0; i < DIGITS; i++)
		n1[i] = n2[i];
}

/* moltiplica n1 * n2, mette il risultato in n3 */
void mult(INT n1, INT n2, INT n3)
{
    int i,j,r,l1,l2;

    /* "ripulisce" n3 */
    for(i = 0; i < DIGITS; i++)
        n3[i] = -1;

    /* ciclo sul primo numero */
    for(i = 0; i < DIGITS; i++) {
        /* se abbiamo raggiunto la cifra piu' grande del primo numero abbiamo finito */
        if((l1 = n1[i]) == -1)
            break;

        /* ciclo sul secondo numero */
        /* r e' il riporto */
        for(j = r = 0; j < DIGITS; j++) {
		/* dobbiamo aggiornare la (i+j)esima cifra del prodotto */

            /* abbiamo raggiunto la cifra piu' grande del secondo numero:
               sistemiamo il riporto e usciamo dal ciclo interno */
            if((l2 = n2[j]) == -1) {
                n3[i+j] = r;
                break;
            }

            /* Controlliamo se la (i+j)esima cifra e' raggiunta
               per la prima volta */
            if(j >= i)
                /* se n3[i+j] == -1 dobbiamo porlo a 0 */
                n3[i+j] = max(n3[i+j], 0);

            /* aggiorniamo, tenendo conto del riporto */
            n3[i+j] += l1 * l2 + r;
            /* calcoliamo nuovo riporto */
            r = n3[i+j] / 10;
            /* se n3[i+j] e' piu' grande di 9: */
            n3[i+j] %= 10;
        }
    }

    /* elimina eventuali 0 che appaiano in testa */
    for(i = DIGITS - 1; i > 0; i--)
        if(n3[i] != -1) {
            if(n3[i] == 0)
                n3[i] = -1;
            break;
        }
}

int main(void)
{
	INT n1,n2,n3;
	int i,n,ns;

	for(;;) {
		do {
			printf("Immetti n:\n");
			if((ns = scanf("%d",&n)) != 1)
			fprintf(stderr,"Errore in lettura! Riprova:\n");
			while(getchar() != '\n');
		} while(ns != 1);	
		carica(n2,1);
		for(i = 1;i <= n;i++) {	
			carica(n1,i);
			mult(n1,n2,n3);
			copia(n2,n3);
		}
		printf("%d! = ",n);
		stampa(n2);
		putchar('\n');
	}
}

